/// <reference types="node" />
import * as dgram from "dgram";
import { EventEmitter } from "events";
import { Logger } from "../shared/Logger";
export declare enum MetricType {
    Counter = "c",
    Gauge = "g",
    Histogram = "ms",
}
export interface Stat {
    type: MetricType;
    value: string;
}
export interface Metric {
    name: string;
    labels: {
        [key: string]: string;
    };
    stats: Stat[];
}
export interface StatsdReceiverConfiguration {
    logger: Logger;
}
export declare class StatsdReceiver extends EventEmitter {
    private socket;
    private logger;
    constructor(config: StatsdReceiverConfiguration);
    start(): Promise<dgram.Socket>;
    private handleMessage(msg, rinfo);
    private parseMetricGracefully(line);
    private parseMetric(line);
    private parseNamespace(namespace);
    private parseStat(stat);
}
